various fixes and improvements
[automated-distro-installer] / fai / config / hooks / partition.DEFAULT
index 2dc6fd50776210ffa8ee80b88c059414b65f5f59..7a1967b2268b002bb3f76d8a734df652db99d6f8 100755 (executable)
@@ -1,26 +1,91 @@
 #!/bin/bash -x
+# Copyright (C) 2016 Ian Kelling
+
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
+# for calling outside of FAI, first
+# source /a/bin/fai-wrapper
+# then to set classes with: fai-setclass OPT1...
+# which sets CLASS_OPT1=true...
+#
+# OPTIONS:
+#
+# environment variables:
+#
+# HOSTNAME: if frodo, we exclude 2 devices from the /boot array, which
+# the bios does not see. if demohost, we set the luks password to just
+# 'x'.
+#
+# SPECIAL_DISK: For use outside of fai. A base disk name like
+# /dev/sdk. If set, we just cryptsetup and partition this one disk then
+# exit. This is useful for partitioning a disk in preparation to replace
+# a failed or failing disk from a raid10 array.
+#
+# classes:
+#
+# REPARTITION: forces repartitioning even if we detect the proper amount
+# of partitions already exist.
+#
+# ROTATIONAL: forces to install onto hdds instead of sdds. normally sdds
+# are chosen if they exist.
+#
+# PARTITION_PROMPT: command line prompt before partitioning
+#
+# RAID0: forces raid0 filesystem. Normally with 4+ devices, we use
+# raid10.
+
+if [[ $SPECIAL_DISK ]]; then
+    export CLASS_REPARTITION=true
+fi
+
 # # fai's setup-storage won't do btrfs on luks,
 # # so we do it ourself :)
+# inspiration taken from files in fai-setup-storage package
+
+# if we are not running in fai, skiptask won't be defined, so carry on.
+skiptask partition || ! type skiptask
+
 
-skiptask partition || ! type skiptask # for running not in fai
 
 #### begin configuration
 
 rootn=1
 swapn=2
 bootn=3
-bios_grubn=4
-boot_mib=1500
+# ext partition so grub can write persistent variables,
+# so it can do a one time boot. grub can't write to
+# btrfs or any cow fs because it's more
+# more complicated to do and they don't want to.
+grub_extn=4
+# bios boot partition,
+# https://wiki.archlinux.org/index.php/GRUB
+bios_grubn=5
+lastn=$bios_grubn
+# this is larger than needed for several /boot subvols,
+# becuase I keep a minimal debian install on it, for
+# recovery needs, and for doing pxe-kexec.
+boot_mib=10000
 
 
 ##### end configuration
 
 
-add-part() {
+add-part() { # add partition suffix to $dev
     local d ret
     if [[ $# == 1 ]]; then
         d=$dev
@@ -40,6 +105,7 @@ add-part() {
 bootdev() { add-part $@ $bootn; }
 rootdev() { add-part $@ $rootn; }
 swapdev() { add-part $@ $swapn; }
+grub_extdev() { add-part $@ $grub_extn; }
 bios_grubdev() { add-part $@ $bios_grubn; }
 
 crypt-dev() { echo /dev/mapper/crypt_dev_${1##*/}; }
@@ -48,7 +114,14 @@ root-cryptdev() { crypt-dev $(rootdev $@); }
 swap-cryptdev() { crypt-dev $(swapdev $@); }
 root-cryptname() { crypt-name $(rootdev $@); }
 swap-cryptname() { crypt-name $(swapdev $@); }
+devbyid() {
+    local f
+    for f in $FAI/distro-install-common/devbyid \
+                 /a/bin/fai/fai/config/distro-install-common/devbyid; do
+        if [[ -e $f ]]; then $f "$@"; break; fi
+    done
 
+}
 
 ##### end function defs
 
@@ -58,7 +131,6 @@ else
     partition=false # change to true to force a full wipe
 fi
 
-lastn=$bios_grubn
 
 
 hdds=()
@@ -74,7 +146,7 @@ $(cat $disk/queue/rotational)"; exit 1 ;;
 done
 
 # install all ssds, or if there are none, all hdds
-if (( ${#ssds[@]} > 0 )); then
+if ! ifclass ROTATIONAL && (( ${#ssds[@]} > 0 )); then
     short_devs=( ${ssds[@]} )
 else
     short_devs=( ${hdds[@]} )
@@ -83,10 +155,10 @@ fi
 # check if the partitions exist have the right filesystems
 #blkid="$(blkid -s TYPE)"
 for dev in ${short_devs[@]}; do
-    ! $partition || break
+    if $partition; then break; fi
     y=$(readlink -f $dev)
-    x=($y[0-9])
-    [[ ${#x[@]}  == "${lastn}" ]] || partition=true
+    arr=($y[0-9])
+    [[ ${#arr[@]}  == "${lastn}" ]] || partition=true
     for (( i=1; i <= lastn; i++ )); do
         [[ -e ${dev}$i ]] || partition=true
     done
@@ -100,8 +172,8 @@ done
 
 if $partition && ifclass PARTITION_PROMPT; then
     echo "Press any key except ctrl-c to continue and partition these drives:"
-    echo "  ${short_devs[@]}"
-    read
+    echo "  ${short_devs[*]}"
+    read -r
 fi
 
 devs=()
@@ -111,7 +183,7 @@ for short_dev in ${short_devs[@]}; do
 done
 
 
-
+first=false
 boot_devs=()
 for dev in ${devs[@]}; do
     if ifclass frodo; then
@@ -142,33 +214,51 @@ for dev in ${devs[@]}; do
     else
         boot_devs+=(`bootdev`)
     fi
+    if [[ $boot_devs && $first ]]; then
+        first_grub_extdev=`grub_extdev`
+        first=false
+    fi
 done
 
-if [[ ! $DISTRO ]]; then
-    if ifclass STABLE; then
-        DISTRO=debianstable
-    else
-        DISTRO=debiantesting
-    fi
+if ifclass RAID0 || (( ${#boot_devs[@]} < 4 )); then
+    raid_level=0
+else
+    raid_level=10
+    # need double the space if we are raid 10, and then
+    # might as well give some extra.
+    boot_mib=$((boot_mib * 3))
 fi
 
 
 
-case ${#boot_devs[@]} in
-    # need double the space if we are raid 10, and then
-    # might as well give some extra overhead.
-    [4-9]*|[1-3]?*) boot_mib=$((boot_mib * 3)) ;;
-esac
+if [[ ! $DISTRO ]]; then
+    if ifclass VOL_STRETCH_BOOTSTRAP; then
+        DISTRO=debianstretch_bootstrap
+    elif ifclass VOL_STRETCH; then
+        DISTRO=debianstretch
+    elif ifclass VOL_TESTING; then
+        DISTRO=debiantesting
+    elif ifclass VOL_XENIAL; then
+        DISTRO=ubuntuxenial
+    elif ifclass VOL_BELENOS; then
+        DISTRO=trisquelbelenos
+    elif ifclass VOL_FLIDAS; then
+        DISTRO=trisquelflidas
+    else
+        echo "PARTITIONER ERROR: no distro class/var set" >&2
+        exit 1
+    fi
+fi
+first_boot_dev=${boot_devs[0]}
 
 
 bpart() { # btrfs a partition
-    case ${#@} in
-        [1-3]) mkfs.btrfs -f $@ ;;
-        [4-9]*|[1-3]?*) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
+    case $raid_level in
+        0) mkfs.btrfs -f $@ ;;
+        10) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
     esac
 }
 
-first_boot_dev=${boot_devs[0]}
 
 # keyfiles generated like:
 # head -c 2048 /dev/urandom | od | s dd of=/q/root/luks/host-demohost
@@ -179,11 +269,11 @@ if [[ ! -e $luks_dir/host-$HOSTNAME ]]; then
     exit 1
 fi
 
-if ifclass tp; then
-    lukspw=$(cat $luks_dir/traci)
-else
-    lukspw=$(cat $luks_dir/ian)
-fi
+lukspw=$(cat $luks_dir/iank)
+# # ian: disabled while I use the tp host.
+# if ifclass tp; then
+#     lukspw=$(cat $luks_dir/traci)
+fi
 if ifclass demohost; then
     lukspw=x
 fi
@@ -191,7 +281,6 @@ fi
 
 first_root_crypt=$(root-cryptdev ${devs[0]})
 
-bios_grubn=4
 # 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
 swap_mib=$(( $(grep ^MemTotal: /proc/meminfo | \
                    awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1024 ))
@@ -203,23 +292,37 @@ for dev in ${devs[@]}; do
 done
 shopt -s nullglob
 if $partition; then
-    for dev in ${devs[@]}; do
-        for x in $dev[0-9]; do
-            count_down=10
-            # wipefs has failed, manual run works, google suggests timing issue
-            while ! wipefs -a $x; do
-                sleep 2
-                count_down=$((count_down - 1))
-                (( count_down > 0 )) || exit 1
+
+    ### begin wipefs
+    if [[ ! $SPECIAL_DISK ]]; then
+        for dev in ${devs[@]}; do
+            # if we repartition to the same as an old partition,
+            # we don't want any old fses hanging around.
+            for (( i=1; i <= lastn; i++ )); do
+                x=$(add-part $dev $i)
+                [[ -e $x ]] || continue
+                count_down=10
+                # wipefs has failed, manual run works, google suggests timing issue
+                while ! wipefs -a $x; do
+                    sleep 2
+                    count_down=$((count_down - 1))
+                    (( count_down > 0 )) || exit 1
+                done
             done
         done
-    done
+    fi
+    ### end wipefs
+
     for dev in ${devs[@]}; do
+        if [[ $SPECIAL_DISK ]]; then
+            dev=$(devbyid $SPECIAL_DISK)
+        fi
+
         # parted will round up the disk size. Do -1 so we can have
         # fully 1MiB unit partitions for easy resizing of the last partition.
         # Otherwise we would pass in -0 for the end argument for the last partition.
         #
-        # parted print error output is expected. example:
+        # Note: parted print error output is expected. example:
         # Error: /dev/vda: unrecognised disk label
         disk_mib=$(( $(parted -m $dev unit MiB print | \
                            sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
@@ -227,28 +330,56 @@ if $partition; then
         swap_end=$(( root_end + swap_mib))
 
         parted -s $dev mklabel gpt
-        # gpt ubuntu cloud image uses ~4. fai uses 1 MiB.
-        # I read something in the parted manual saying cheap flash media
-        # likes to start at 4.
         # MiB because parted complains about alignment otherwise.
         pcmd="parted -a optimal -s -- $dev"
-        $pcmd mkpart primary "ext3" 4MiB ${root_end}MiB
-        $pcmd mkpart primary "linux-swap" ${root_end}MiB ${swap_end}MiB
+        $pcmd mkpart primary ext3 12MiB ${root_end}MiB
+        # without naming, systemd gives us misc errors like:
+        # dev-disk-by\x2dpartlabel-primary.device: Dev dev-disk-by\x2dpartlabel-primary.device appeared twice
+        $pcmd name $rootn root
+        # normally a swap is type "linux-swap", but this is encrypted swap. using that
+        # label will confuse systemd.
+        $pcmd mkpart primary "" ${root_end}MiB ${swap_end}MiB
+        $pcmd name $swapn swap
         $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
+        $pcmd name $bootn boot
+        # i only need a few k, but googling min size,
+        # I found someone saying that gparted required
+        # required at least 8 because of their hard drive cylinder size.
+        # And 8 is still very tiny.
+        $pcmd mkpart primary "ext2" 4MiB 12MiB
+        $pcmd name $grub_extn grubext
+        # gpt ubuntu cloud image uses ~4 mb for this partition. fai uses 1 MiB.
+        # so, I use 3, whatever.
+        # note: parted manual saying cheap flash media
+        # should to start at 4.
         $pcmd mkpart primary "" 1MiB 4MiB
+        $pcmd name $bios_grubn biosgrub
         $pcmd set $bios_grubn bios_grub on
         $pcmd set $bootn boot on # generally not needed on modern systems
         # the mkfs failed before on a vm, which prompted me to add
         # sleep .1
-        # then failed on a physical machine
+        # then it failed again on a physical machine
         # with:
         # Device /dev/disk/by-id/foo doesn't exist or access denied,
-        # so here we wait.
+        # so I added a wait until it existed.
+        # Then I added the mkfs.ext2, which claimed to succeed,
+        # but then couldn't be found upon reboot. In that case we didn't
+        # wait at all. So I've added a 3 second minimum wait.
+        sleep 3
         secs=0
         while [[ ! -e `rootdev` ]] && (( secs < 10 )); do
             sleep 1
             secs=$((secs +1))
         done
+        # Holds just a single file, rarely written, so
+        # use ext2, like was often used for the /boot partition.
+        # This exists because grub can only persist data to a non-cow fs.
+        # And we use persisting a var in grub to do a one time boot.
+        # We could pass the data on the kernel command line and persist it
+        # to grubenv after booting, but that relies on the boot always succeeding.
+        # This is just a bit more robust, and it could work for booting
+        # into ipxe which can't persist data, if we ever got that working.
+        mkfs.ext2 `grub_extdev`
         yes YES | cryptsetup luksFormat `rootdev` $luks_dir/host-$HOSTNAME \
                              -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
         yes "$lukspw" | \
@@ -266,91 +397,119 @@ if $partition; then
 
         cryptsetup luksOpen `rootdev` `root-cryptname` \
                    --key-file $luks_dir/host-$HOSTNAME
+
+        if [[ $SPECIAL_DISK ]]; then
+            exit 0
+        fi
     done
-    ls -la /dev/btrfs-control
+    ls -la /dev/btrfs-control # this was probably for debugging...
     sleep 1
     bpart $(for dev in ${devs[@]}; do root-cryptdev; done)
     bpart ${boot_devs[@]}
 else
     for dev in ${devs[@]}; do
+        mkfs.ext2 `grub_extdev`
         cryptsetup luksOpen `rootdev` `root-cryptname` \
                    --key-file $luks_dir/host-$HOSTNAME
     done
     sleep 1
 fi
 
-mount -o subvolid=0 $first_root_crypt /mnt
-# systemd creates subvolumes we want to delete.
-s=($(btrfs subvolume list --sort=-path /mnt |
-         sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
-for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
-btrfs subvolume set-default 0 /mnt
-[[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
 
-## create subvols ##
-cd /mnt
-btrfs subvolume create root_$DISTRO
-chown root:1000 q
-
-mkdir -p /mnt/root_$DISTRO/boot
-for x in root/a q/a; do
-    mkdir -p $x
-    chown 1000:1000 $x
-    chmod 755 $x
-done
-# could set default like this, but no reason to.
-# btrfs subvolume set-default \
-    #       $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
-chattr -Rf +C root_$DISTRO
-cd /
-umount /mnt
+if [[ $DISTRO != debianstretch_bootstrap ]]; then
+    # bootstrap distro doesn't use separate encrypted root.
+    mount -o subvolid=0 $first_root_crypt /mnt
+    # systemd creates subvolumes we want to delete.
+    s=($(btrfs subvolume list --sort=-path /mnt |
+             sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
+    for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
+    btrfs subvolume set-default 0 /mnt
+    [[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
+
+    ## create subvols ##
+    cd /mnt
+
+    btrfs subvolume create root_$DISTRO
+
+    mkdir -p /mnt/root_$DISTRO/boot
+    # could set default subvol like this, but no reason to.
+    # btrfs subvolume set-default \
+        #       $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
+
+    # no cow on the root filesystem. it's setup is fully scripted,
+    # if it's messed up, we will just recreated it,
+    # and we can get better perf with this.
+    # I can't remember exactly why, but this is preferable to mounting with
+    # -o nodatacow, I think because subvolumes inherit that.
+    chattr -Rf +C root_$DISTRO
+    cd /
+    umount /mnt
+fi
+
 mount -o subvolid=0 $first_boot_dev /mnt
 cd /mnt
-btrfs subvolume set-default 0 /mnt
-[[ ! -e /mnt/boot_$DISTRO ]] || btrfs subvolume delete /mnt/boot_$DISTRO
-btrfs subvolume create boot_$DISTRO
+btrfs subvolume set-default 0 /mnt # already default, just ensuring it.
+
+# for libreboot systems. grub2 only reads from subvolid=0
+mkdir -p /mnt/grub2
+cp $FAI/distro-install-common/libreboot_grub.cfg /mnt/grub2
+
+if [[ $DISTRO == debianstretch_bootstrap ]]; then
+    # this is just convenience for the libreboot_grub config
+    # so we can glob the other ones easier.
+    boot_vol=$DISTRO
+else
+    boot_vol=boot_$DISTRO
+fi
+[[ ! -e /mnt/$boot_vol ]] || btrfs subvolume delete /mnt/$boot_vol
+btrfs subvolume create $boot_vol
 cd /
 umount /mnt
 ## end create subvols ##
 
+dev=${boot_devs[0]}
+mount $first_grub_extdev /mnt
+grub-editenv /mnt/grubenv set did_fai_check=true
+grub-editenv /mnt/grubenv set last_boot=/$boot_vol
+umount /mnt
 
-
-cat > /tmp/fai/fstab <<EOF
-$first_root_crypt  /  btrfs  noatime,subvol=root_$DISTRO  0 0
-$first_root_crypt  /q  btrfs  noatime,subvol=q  0 0
-/q/a  /a  none  bind  0 0
-$first_boot_dev  /boot  btrfs  noatime,subvol=boot_$DISTRO  0 0
+if [[ $DISTRO == debianstretch_bootstrap ]]; then
+    cat > /tmp/fai/fstab <<EOF
+$first_boot_dev  /  btrfs  noatime,subvol=$boot_vol  0 0
 EOF
-
-
-if ifclass treetowl; then
-    cat >> /tmp/fai/fstab <<'EOF'
-UUID=3f7b31cd-f299-40b4-a86b-7604282e2715 /i btrfs  noatime    0 2
+    cat >/tmp/fai/disk_var.sh <<EOF
+BOOT_DEVICE="${short_devs[@]}"
+ROOT_PARTITION=$first_boot_dev
 EOF
-fi
-
-swaps=()
-for dev in ${devs[@]}; do
-    swaps+=(`swap-cryptname`)
-    cat >>/tmp/fai/crypttab <<EOF
+else
+    # note, fai creates the mountpoints listed here
+    cat > /tmp/fai/fstab <<EOF
+$first_root_crypt  /  btrfs  noatime,subvol=root_$DISTRO  0 0
+$first_root_crypt  /mnt/root  btrfs  noatime,subvolid=0  0 0
+$first_boot_dev  /boot  btrfs  noatime,subvol=$boot_vol  0 0
+EOF
+    swaps=()
+    for dev in ${devs[@]}; do
+        swaps+=(`swap-cryptname`)
+        cat >>/tmp/fai/crypttab <<EOF
 `root-cryptname`  `rootdev`  none  keyscript=/root/keyscript,discard,luks
 `swap-cryptname` `swapdev`  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
 EOF
-    cat >> /tmp/fai/fstab <<EOF
+        cat >> /tmp/fai/fstab <<EOF
 `swap-cryptdev`  none  swap  sw  0 0
 EOF
-done
-
-# fai would do this:
-#BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
+    done
 
-# swaplist seems to do nothing.
+    # fai would do this:
+    #BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
 
-cat >/tmp/fai/disk_var.sh <<EOF
+    # note: swaplist seems to do nothing.
+    cat >/tmp/fai/disk_var.sh <<EOF
+BOOT_DEVICE="${short_devs[@]}"
+BOOT_PARTITION=\${BOOT_PARTITION:-$first_boot_dev}
 # ROOT_PARTITIONS is added by me, used in arch setup.
 ROOT_PARTITIONS="${root_devs[@]}"
 ROOT_PARTITION=\${ROOT_PARTITION:-$first_root_crypt}
-BOOT_PARTITION=\${BOOT_PARTITION:-$first_boot_dev}
-BOOT_DEVICE="${short_devs[@]}"
 SWAPLIST=\${SWAPLIST:-"${swaps[@]}"}
 EOF
+fi